// Ex-p5-Audio3-File-FFT
// Click Mouse play a sound
// Pour p5.js
// 30 12 2016
// Utilise: libraries/p5.js
// Utilise: libraries/p5.sound.js
// http://p5js.org/reference/#/p5.FFT
// http://p5js.org/reference/#/p5.FFT/analyze

NomSon = "Eau3-5sec-Envelop.mp3";
var Son;

function preload() {
  Son = loadSound(NomSon);
}

function setup() {
  createCanvas(windowWidth, windowHeight);
  fft = new p5.FFT();
  Son.loop();
  fft.setInput(Son);
  noStroke();
  fill(50, 150, 50); // Green
}

function draw() {
  background(255);
  var spectrum = fft.analyze();
  var Largeur = int(width / spectrum.length) + 2;
  for (var i = 0; i < spectrum.length; i++) {
    var x = map(i, 0, spectrum.length, 0, width);
    var h = -height + map(spectrum[i], 0, 255, height, 0);
    rect(x, height, Largeur, h)
  }
  text('click to play/pause ', 8, 16);
}

function mousePressed() {
  if (Son.isPlaying()) Son.pause();
  else Son.loop();
}

function windowResized() {
  resizeCanvas(windowWidth, windowHeight);
}